//+------------------------------------------------------------------+
//|                                                          123.mqh |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CObjectArrow
  {
   string            names;

public:
   void              Create(long chart_id,const string name,const int window,
                            const datetime time,const double price,ENUM_OBJECT code)
     {
      names=name;
      ObjectCreate(chart_id,name,code,window,time,price);
     }
   void  CObjectArrow() {names="";}
   void  Delete() {ObjectDelete(0,names);}
   void  ~CObjectArrow() {ObjectMove(0,names,0,0,0);}

  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CObjectLine
  {
  public:
   string            names;


   void              Create(long chart_id,const string name,ENUM_OBJECT code,
                            const datetime time,const double price,
                            const datetime time2,const double price2)
     {
      names=name;
      ObjectCreate(chart_id,name,code,0,time,price,time2,price2);
     }
   void  Color(color clr){ObjectSetInteger(0,names,OBJPROP_COLOR,clr);}
   void  Style(){ObjectSetInteger(0,names,OBJPROP_STYLE,STYLE_DOT);}
   void  CObjectLine() {names="";}
   void  Delete() {ObjectDelete(0,names);}
   void  Hide() {ObjectMove(0,names,0,0,0);ObjectMove(0,names,1,0,0);}
   void  ~CObjectLine() {ObjectMove(0,names,0,0,0);ObjectMove(0,names,1,0,0);}

  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CObjectText
  {
    string            names;

public:
   void              Create(long chart_id,const string name,const int window,
                            const datetime time,const double price,ENUM_OBJECT code,int text)
     {
      names=name;
      ObjectCreate(chart_id,name,code,window,time,price);
      if(_Digits==5 || _Digits==3)text=(int)(text*0.1);
      ObjectSetString(chart_id,name,OBJPROP_TEXT,(string)text);
     }
   void  CObjectText() {names="";}
   void  Delete() {ObjectDelete(0,names);}
   void  ~CObjectText() {ObjectMove(0,names,0,0,0);}

  };
  
//+------------------------------------------------------------------+
