//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 40
#property indicator_plots   20

#include "CMyBuffer.mqh"   //a simple class
#include "MT5_v2_FastFile.mqh"
#include "Cindikator_add.mqh"
#include "MT5_v2_indikator_del.mqh"

#resource "\\Indicators\\Entropy.ex5"
#resource "\\Indicators\\Smirnoff_h.ex5"

input int   Param1=-1;
input int   Param2=-1;
input int   Param3=0;
input int   Param4=0;
CMyBuffer Buffer[];

CMyBuffer ClrBuffer[];
int tmp=0,hendl=-1,calculate,rekalkulate=-1;
double Parametr[],Buferrez[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void Init()
  {

   for(int i=0; i<ArraySize(Buffer); i++)
     {
      if(true)
        {
         Buffer[i].mSetIndexBuffer(i+1*i,INDICATOR_DATA);
         ClrBuffer[i].mSetIndexBuffer(i+1+1*i,INDICATOR_COLOR_INDEX);
        }
     }
   for(int i=0; i<ArraySize(Buffer); i++)
     {
      if(true)
        {

         Buffer[i].mPlotIndexSetInteger(i,PLOT_DRAW_TYPE,DRAW_COLOR_LINE);
         Buffer[i].mPlotIndexSetInteger(i,PLOT_LINE_STYLE,STYLE_SOLID);
         Buffer[i].mPlotIndexSetInteger(i,PLOT_COLOR_INDEXES,6);
         Buffer[i].mPlotIndexSetInteger2(i,PLOT_LINE_COLOR,0,clrBlue);
         Buffer[i].mPlotIndexSetInteger2(i,PLOT_LINE_COLOR,1,clrSilver);
         Buffer[i].mPlotIndexSetInteger2(i,PLOT_LINE_COLOR,2,clrBrown);
         Buffer[i].mPlotIndexSetInteger2(i,PLOT_LINE_COLOR,3,clrGreen);
         Buffer[i].mPlotIndexSetInteger2(i,PLOT_LINE_COLOR,4,clrDeepSkyBlue);
         Buffer[i].mPlotIndexSetInteger2(i,PLOT_LINE_COLOR,5,clrSalmon);
         Buffer[i].mPlotIndexSetInteger(i,PLOT_LINE_WIDTH,2);
        }
     }
   rekalkulate=1;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnInit()
  {
   ArrayResize(Buffer,Param3);
   ArrayResize(ClrBuffer,Param3);
   ArrayResize(Buferrez,Param3+1);
// IndicatorSetInteger(INDICATOR_HEIGHT, 20);
//--- indicator buffers mapping
   Init();

   if(Param2>=0)falecopy4();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   if(hendl>0)hendl=Indukator_del(hendl);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {

// if(Param1>0 && rekalkulate<0){falecopy3();rekalkulate=1;}
   if(Param2>=0 && ArraySize(Buferrez)>0)
     {
      for(int i=0;i<ArraySize(Buffer);i++)
        {
         if(rekalkulate>0)
           {
            tmp=Buffer[i].mCopyBuffer(0,rates_total,(int)Buferrez[i+1]);
            for(int f=1;f<rates_total;f++)
              {
               if(Buffer[i].mbuffer[f]>Buffer[i].mbuffer[f-1])
                 {
                  ClrBuffer[i].mbuffer[f]=4;
                 }
               else
                 {
                  ClrBuffer[i].mbuffer[f]=5;
                 }
              }
           }
         else
           {
            tmp=Buffer[i].mCopyBuffer(rates_total,prev_calculated,(int)Buferrez[i+1]);
            if(Buffer[i].mbuffer[rates_total-1]>Buffer[i].mbuffer[rates_total-2])
               ClrBuffer[i].mbuffer[rates_total-1]=4;
            else
               ClrBuffer[i].mbuffer[rates_total-1]=5;
           }

        }
      if(ArraySize(Buffer)==ArraySize(Buferrez)-1)
         rekalkulate=-1;
     }
   return rates_total;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
//---
   if(sparam=="Neuro_plus_indikator_2")
     {
      switch(Param4)
        {
         case 0:

            break;
         case 1:
            PlotIndexSetInteger(0,PLOT_DRAW_TYPE,DRAW_COLOR_LINE);
            ChartRedraw();
            tmp=0;

            break;
         case 2:
            PlotIndexSetInteger(0,PLOT_DRAW_TYPE,DRAW_COLOR_HISTOGRAM);
            ChartRedraw();
            tmp=0;
            break;
         case 3:
            if(Param4!=lparam)break;
            falecopy();
            tmp=0;
            //Print(6);
            break;
         case 4:
            if(Param4!=lparam)break;
            falecopy2();
            tmp=0;
            //Print(4);
            break;
         case 5:
            if(Param4!=lparam)break;
            falecopy3();
            tmp=0;
            //Print(5);
            break;
         case 6:
            if(Param4!=lparam || Param2!=(int)dparam)break;
            falecopy4();
            tmp=0;
            //Print(6);
            break;
         case 7:
            if(Param4!=lparam)break;

            for(int i=0;i<ArraySize(Buffer);i++)
              {
               if(ArraySize(Buffer)==ArraySize(Buferrez)-1)tmp=Buffer[i].mCopyBuffer(0,Bars(NULL,0),(int)Buferrez[i+1]);
              }
            if(ArraySize(Buffer)!=ArraySize(Buferrez)-1)falecopy4();
            ChartRedraw();
            //Print(7);
            break;
         case 8:

            if(Param4!=lparam)break;
            falecopy5();
            tmp=0;
            //Print(8);
            break;
         case 9:
            if(Param4!=lparam)break;
            falecopy1();
            tmp=0;
            //Print(9);
            break;
        }
     }
   return;
//---
  }
//+------------------------------------------------------------------+

void falecopy()//   
  {
   ArrayInitialize(Buffer[0].mbuffer,EMPTY_VALUE);
   datetime         time_array[];
   CFastFile *tp=new CFastFile; //   
   tp.Load("dataneuro"+(string)ChartID()+".txt");     //      
   int t3=tp.ReadInt();
   int t2=tp.ReadInt();
   int t1=tp.ReadInt();
   tp.Clear();
   delete tp;

   int   i2=Bars(NULL,0);
   tp=new CFastFile; //   
   tp.Load("dataneuro2"+(string)ChartID()+".txt");     //    
   int i=CopyTime(_Symbol,_Period,(datetime)SeriesInfoInteger(_Symbol,_Period,SERIES_LASTBAR_DATE),(datetime)t3,time_array);
   while(i2>1)
     {
      i2--;
      if(tp.IsEnding())break;
      Buffer[0].mbuffer[i2]=tp.ReadDouble();
      if(i<1)i=1;
      if(time_array[i-1]>=t3)ClrBuffer[0].mbuffer[i2]=1;
      if(time_array[i-1]>=t2)ClrBuffer[0].mbuffer[i2]=2;
      if(time_array[i-1]>=t1)ClrBuffer[0].mbuffer[i2]=3;
      i--;
     }
   tp.Clear();
   delete tp;
   ChartRedraw();

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void falecopy1()//   
  {
   ArrayInitialize(Buffer[0].mbuffer,EMPTY_VALUE);
   datetime         time_array[];
   CFastFile *tp=new CFastFile; //   
   tp.Load("dataneuro"+(string)ChartID()+".txt");     //      
   int t3=tp.ReadInt();
   int t2=tp.ReadInt();
   int t1=tp.ReadInt();
   tp.Clear();
   delete tp;

   int   i2=Bars(NULL,0);
   tp=new CFastFile; //   
   tp.Load("dataneuro3"+(string)ChartID()+".txt");     //    
   int i=CopyTime(_Symbol,_Period,(datetime)SeriesInfoInteger(_Symbol,_Period,SERIES_LASTBAR_DATE),(datetime)t3,time_array);
   while(i2>1)
     {
      i2--;
      if(tp.IsEnding())break;
      Buffer[0].mbuffer[i2]=tp.ReadDouble();
      if(i<1)i=1;
      if(time_array[i-1]>=t3)ClrBuffer[0].mbuffer[i2]=1;
      if(time_array[i-1]>=t2)ClrBuffer[0].mbuffer[i2]=2;
      if(time_array[i-1]>=t1)ClrBuffer[0].mbuffer[i2]=3;
      i--;
     }
   tp.Clear();
   delete tp;
   ChartRedraw();

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void falecopy2()//     
  {
   ArrayInitialize(Buffer[1].mbuffer,EMPTY_VALUE);
   ArrayInitialize(Buffer[0].mbuffer,EMPTY_VALUE);
   Buffer[1].mPlotIndexSetInteger(1,PLOT_LINE_WIDTH,1);
   Buffer[1].mPlotIndexSetInteger2(1,PLOT_LINE_COLOR,0,clrBlue);
   datetime         time_array[];
   CFastFile *tp=new CFastFile; //   
   tp.Load("dataneuro"+(string)ChartID()+".txt");     //      
   int t3=tp.ReadInt();
   int t2=tp.ReadInt();
   int t1=tp.ReadInt();
   tp.Clear();
   delete tp;

   int   i2=Bars(NULL,0);
   tp=new CFastFile; //   
   tp.Load("dataneuro2"+(string)ChartID()+".txt");     //    
   int i=CopyTime(_Symbol,_Period,(datetime)SeriesInfoInteger(_Symbol,_Period,SERIES_LASTBAR_DATE),(datetime)t3,time_array);
   while(i2>1)
     {
      i2--;
      if(tp.IsEnding())break;
      Buffer[0].mbuffer[i2]=tp.ReadDouble();
      if(i<1)i=1;
      if(time_array[i-1]>=t3)ClrBuffer[0].mbuffer[i2]=1;
      if(time_array[i-1]>=t2)ClrBuffer[0].mbuffer[i2]=2;
      if(time_array[i-1]>=t1)ClrBuffer[0].mbuffer[i2]=3;
      i--;
     }
   tp.Clear();
   delete tp;

   i2=Bars(NULL,0);
   tp=new CFastFile; //   
   tp.Load("dataneuro3"+(string)ChartID()+".txt");     //    
   i=CopyTime(_Symbol,_Period,(datetime)SeriesInfoInteger(_Symbol,_Period,SERIES_LASTBAR_DATE),(datetime)t3,time_array);

   while(i2>1)
     {
      i2--;
      if(tp.IsEnding())break;
      Buffer[1].mbuffer[i2]=tp.ReadDouble();
      if(i<1)i=1;
      ClrBuffer[1].mbuffer[i2]=0;
      i--;
     }
   tp.Clear();
   delete tp;
   ChartRedraw();

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void falecopy3()
  {
   ArrayInitialize(Buffer[0].mbuffer,EMPTY_VALUE);
   Buffer[0].mPlotIndexSetInteger2(1,PLOT_LINE_COLOR,0,clrBlue);
   datetime         time_array[];
   CFastFile *tp=new CFastFile; //   
   tp.Load("dataneuro"+(string)ChartID()+".txt");     //      
   int t3=tp.ReadInt();
   int t2=tp.ReadInt();
   int t1=tp.ReadInt();
   tp.Clear();
   delete tp;

   int   i2=Bars(NULL,0);
   tp=new CFastFile; //   
   tp.Load("dataneuro"+(string)ChartID()+"_"+(string)Param1+".txt");     //    
   tp.Delim('#');
   IndicatorSetString(INDICATOR_SHORTNAME,tp.ReadString(-1));
   IndicatorSetInteger(INDICATOR_HEIGHT,tp.ReadInteger(-1));
   int i=CopyTime(_Symbol,_Period,(datetime)SeriesInfoInteger(_Symbol,_Period,SERIES_LASTBAR_DATE),(datetime)t3,time_array);
   while(i2>i-1)
     {
      i2--;
      if(tp.IsEnding())break;
      Buffer[0].mbuffer[i2]=tp.ReadDouble();
     }
   tp.Clear();
   delete tp;
   ChartRedraw();
   rekalkulate=1;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void falecopy4()
  {

   Cindikator_add    indikator_add;
   string         StringArray[],StringArray2[];

   CFastFile *tp=new CFastFile; //   
   tp.Load("dataneuro4"+(string)ChartID()+(string)Param2+".txt");     //      
   tp.m_delim=0;
   string t1=tp.ReadString(-1);
   tp.Clear();
   delete tp;
   ArrayResize(StringArray,5);

   tmp=StringSplit(t1,StringGetCharacter("#",0),StringArray);

   if(tmp>0 && tmp>=5)
     {

      ArrayResize(Parametr,1);
      ArrayResize(StringArray2,1);
      IndicatorSetString(INDICATOR_SHORTNAME,StringArray[0]+"("+string(StringArray[1])+")");
      if(hendl>0)hendl=Indukator_del(hendl);
      //---------------------------------------------------------------------------------------------------
      tmp=StringSplit(StringArray[1],StringGetCharacter(";",0),StringArray2);//  
      ArrayResize(Parametr,ArraySize(StringArray2)+1);//  
      for(tmp=1;tmp<ArraySize(StringArray2)+1;tmp++)Parametr[tmp]=(double)StringArray2[tmp-1];//  
      //------------------------------------------------------------------------------------------
      ArrayResize(StringArray2,1);
      tmp=StringSplit(StringArray[2],StringGetCharacter(";",0),StringArray2);//  
      if(ArraySize(StringArray2)==ArraySize(Buferrez))ArrayResize(StringArray2,ArraySize(Buferrez)-1);
      for(tmp=1;tmp<ArraySize(StringArray2)+1;tmp++){Buferrez[tmp]=(int)StringArray2[tmp-1];}//  
      //-------------------------------------------------------------------------------------------
      ArrayResize(StringArray2,1);
      tmp=StringSplit(StringArray[3],StringGetCharacter(";",0),StringArray2);// 
      if(ArraySize(StringArray2)/2>=ArraySize(Buffer))ArrayResize(StringArray2,ArraySize(Buffer)*2);
      for(tmp=0;tmp<ArraySize(StringArray2)/2;tmp++)
        {
         Buffer[tmp].mPlotIndexSetInteger2(tmp,PLOT_LINE_COLOR,4,StringToColor(StringArray2[tmp+1*tmp]));
         Buffer[tmp].mPlotIndexSetInteger2(tmp,PLOT_LINE_COLOR,5,StringToColor(StringArray2[tmp+1+1*tmp]));
        }
      //---------------------------------------------------------------------------------
      ArrayResize(StringArray2,1);
      tmp=StringSplit(StringArray[4],StringGetCharacter(";",0),StringArray2);//  
      if(ArraySize(StringArray2)==ArraySize(Buferrez))ArrayResize(StringArray2,ArraySize(Buferrez)-1);                                                                       //if(ArraySize(StringArray2)==ArraySize(Buferrez))ArrayResize(StringArray2,ArraySize(Buferrez)-1);
      for(tmp=0;tmp<ArraySize(StringArray2);tmp++)//  
        {
         if((int)StringArray2[tmp]==1)Buffer[tmp].mPlotIndexSetInteger(tmp,PLOT_DRAW_TYPE,DRAW_COLOR_LINE);
         if((int)StringArray2[tmp]==2)Buffer[tmp].mPlotIndexSetInteger(tmp,PLOT_DRAW_TYPE,DRAW_COLOR_HISTOGRAM);
        }//  
      //-------------------------------------------------------------------------------------------
      if(hendl<0){Buffer[0].mhandle=indikator_add.add(false,StringArray[0],Parametr);hendl=Buffer[0].mhandle;}
      for(int i=0;i<ArraySize(Buffer);i++)Buffer[i].mhandle=hendl;
      rekalkulate=1;

     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void falecopy5()
  {
   ArrayInitialize(Buffer[0].mbuffer,EMPTY_VALUE);
   datetime         time_array[];
   CFastFile *tp=new CFastFile; //   
   tp.Load("dataneuro"+(string)ChartID()+".txt");     //      
   int t3=tp.ReadInt();
   int t2=tp.ReadInt();
   int t1=tp.ReadInt();
   tp.Clear();
   delete tp;

   int   i2=Bars(NULL,0);
   tp=new CFastFile; //   
   tp.Load("dataneuro5"+(string)ChartID()+(MathAbs(Param1)-1)+".txt");     //    
   tp.Delim('#');
   IndicatorSetString(INDICATOR_SHORTNAME,tp.ReadString(-1));
   IndicatorSetInteger(INDICATOR_HEIGHT,tp.ReadInteger(-1));
   int i=CopyTime(_Symbol,_Period,(datetime)SeriesInfoInteger(_Symbol,_Period,SERIES_LASTBAR_DATE),(datetime)t3,time_array);
   while(i2>1)
     {
      i2--;
      if(tp.IsEnding())break;
      Buffer[0].mbuffer[i2]=tp.ReadDouble();
      if(i<1)i=1;
      if(time_array[i-1]>=t3)ClrBuffer[0].mbuffer[i2]=1;
      if(time_array[i-1]>=t2)ClrBuffer[0].mbuffer[i2]=2;
      if(time_array[i-1]>=t1)ClrBuffer[0].mbuffer[i2]=3;
      i--;
     }
   tp.Clear();
   delete tp;
   ChartRedraw();
   rekalkulate=1;
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
