//+------------------------------------------------------------------+
//|                                                 Export_indi2.mqh |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#include "S_index_param.mqh"
#include "MT5_v2_FastFile.mqh"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CExport_indi2
  {
private:
   CFastFile        *ht;
   int               i;
public:
   void              Export_indi2(double &buf[],int stile_indi,int bufer,S_index_param &index_param);
                     CExport_indi2();
                    ~CExport_indi2();
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CExport_indi2::Export_indi2(double  &buf[],int stile_indi,int bufer,S_index_param &index_param)
  {
   switch(bufer)
     {
      case 0:
         ht=new CFastFile;
         i=ArraySize(buf);
         for(int k=0;k<i;k++)
           {
            ht.WriteDouble(buf[k]);
           }
         ht.Save("dataneuro2"+(string)ChartID()+".txt");
         ht.Clear();
         delete ht;
         
         break;
      case 1:
         ht=new CFastFile;
         i=ArraySize(buf);
         for(int k=0;k<i;k++)
           {
            ht.WriteDouble(buf[k]);
           }
         ht.Save("dataneuro3"+(string)ChartID()+".txt");
         ht.Clear();
         delete ht;
         break;
      case 2:
         ht=new CFastFile;
         i=ArraySize(buf);
         StringToCharArray(index_param.name_setka[stile_indi]+"#",ht.m_data,0,-1,0);
         ht.WriteArray(ht.m_data,0,-1);
         ht.Seek(1,SEEK_END);
         ht.WriteInteger(index_param.height_vision[stile_indi],-1);
         for(int k=0;k<i;k++)
           {
            ht.WriteDouble(buf[k]);
           }
         ht.Save("dataneuro"+(string)ChartID()+"_"+(string)stile_indi+".txt");
         ht.Clear();
         delete ht;
         break;
      case 3://  
         ht=new CFastFile;
         i=ArraySize(buf);
         StringToCharArray(index_param.name_setka[stile_indi]+"#",ht.m_data,0,-1,0);
         ht.WriteArray(ht.m_data,0,-1);
         ht.Seek(1,SEEK_END);
         ht.WriteInteger(index_param.height_vision[stile_indi],-1);
         for(int k=0;k<i;k++)
           {
            ht.WriteDouble(buf[k]);
           }
         ht.Save("dataneuro5"+(string)ChartID()+(string)stile_indi+".txt");
         ht.Clear();
         delete ht;
         break;
      case 4://17 
         ht=new CFastFile;
         i=ArraySize(buf);
         for(int k=0;k<i;k++)
           {
            ht.WriteDouble(buf[k]);
           }
         ht.Save("dataneuro2"+(string)ChartID()+".txt");
         ht.Clear();
         delete ht;
         break;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CExport_indi2::~CExport_indi2()
  {

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CExport_indi2::CExport_indi2()
  {

  }
//+------------------------------------------------------------------+
