//+------------------------------------------------------------------+
//|                                       Neuro_plus_indikator_2.mq5 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "baramantan"
#property link      ""
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 200
#property indicator_plots   100

input int m=4,m_=2;

int   BufSum=1;// 
#include "CMyBuffer.mqh"   //a simple class

CMyBuffer Buffer[];
CMyBuffer ClrBuffer[];

double q1[],q2[],alf;
int j,n,s;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void Init()
  {
   for(int i=0; i<ArraySize(Buffer); i++)
     {
      if(true)
        {
         Buffer[i].mSetIndexBuffer(i+1*i,INDICATOR_DATA);
         ClrBuffer[i].mSetIndexBuffer(i+1+1*i,INDICATOR_COLOR_INDEX);
        }
     }
   for(int i=0; i<ArraySize(Buffer); i++)
     {
      if(true)
        {
         Buffer[i].mPlotIndexSetInteger(i,PLOT_DRAW_TYPE,DRAW_COLOR_LINE);
         Buffer[i].mPlotIndexSetInteger(i,PLOT_LINE_STYLE,STYLE_SOLID);
         Buffer[i].mPlotIndexSetInteger(i,PLOT_COLOR_INDEXES,6);
         Buffer[i].mPlotIndexSetInteger2(i,PLOT_LINE_COLOR,0,clrBlack);
         Buffer[i].mPlotIndexSetInteger2(i,PLOT_LINE_COLOR,1,clrSilver);
         Buffer[i].mPlotIndexSetInteger2(i,PLOT_LINE_COLOR,2,clrBrown);
         Buffer[i].mPlotIndexSetInteger2(i,PLOT_LINE_COLOR,3,clrGreen);
         Buffer[i].mPlotIndexSetInteger2(i,PLOT_LINE_COLOR,4,clrDeepSkyBlue);
         Buffer[i].mPlotIndexSetInteger2(i,PLOT_LINE_COLOR,5,clrSalmon);
         Buffer[i].mPlotIndexSetInteger(i,PLOT_LINE_WIDTH,2);
        }
     }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnInit()
  {
   ArrayResize(Buffer,BufSum);
   ArrayResize(ClrBuffer,BufSum);
   Init();

   alf=2.0/(m_+1);
   n=m-1;
   ArrayResize(q1,n+1);
   ArrayResize(q2,n+1);
   ArrayInitialize(Buffer[0].mbuffer,EMPTY_VALUE);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {

  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {


   for(int i=prev_calculated;i<rates_total;i++)
     {
      q1[0]=close[i];

      for(j=1;j<=n;j++)
        {
         if(i-j<0){Buffer[0].mbuffer[i]=EMPTY_VALUE;continue;}
         q1[j]=q1[j-1]+alf*(close[i-j]-q1[j-1]);
        }
      for(s=1;s<=m/2-1;s++)
        {
         for(j=0;j<=n;j++)
           {
            q2[j]=q1[n-j];
           }
         q1[0]=q2[0];
         for(j=1;j<=n;j++)
           {
            q1[j]=q1[j-1]+alf*(q2[j]-q1[j-1]);
           }
        }
      Buffer[0].mbuffer[i]=q1[n];
      Buffer[0].mbuffer[i]=close[i]-Buffer[0].mbuffer[i];
      ClrBuffer[0].mbuffer[i]=4;
     }

   return rates_total;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
//---

//---
  }
//+------------------------------------------------------------------+
